package org.rzo.yacron4j.example;

import java.text.ParseException;
import java.util.Date;
import java.util.concurrent.Callable;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

import org.rzo.yacron4j.Scheduler;
import org.rzo.yacron4j.TaskOptions;

public class CallableExecution
{

	static int counter = 0;

	/**
	 * @param args
	 * @throws ParseException
	 */
	public static void main(String[] args) throws Exception
	{
		Scheduler scheduler = new Scheduler();
		String cronExpression = "0/1 * * * * ?";
		TaskOptions options = new TaskOptions();
		options.setAllowOverlap(true);
		options.setMaxConcurrent(2);
		final ScheduledFuture task = scheduler.schedule(new Callable()
		{

			public Object call() throws InterruptedException
			{
				System.out.println("" + new Date() + " running "
						+ Thread.currentThread().getName());
				Thread.sleep(5000);
				return counter++;
			}
		}, cronExpression, options);

		System.out.println(new Date(System.currentTimeMillis()
				+ task.getDelay(TimeUnit.MILLISECONDS)));

		new Thread(new Runnable()
		{

			public void run()
			{
				Object result = null;
				try
				{
					// in case of Callable tasks:
					// will block if no results are available yet or if all
					// results have been "gotten"
					// will return null if no results are available and the cron
					// task has terminated
					// will throw an exception if the task has been canceled
					//
					// in case of Runnable:
					// will block until the termination of the next execution
					// will not block if the cron task has terminated
					// will return null
					// will throw an exception if the task has been canceled
					while ((result = task.get()) != null)
					{
						System.out.println("got: " + result);
					}
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		}).start();

		Thread.sleep(15000);
		scheduler.shutdown();
	}

}
